#include <avr/io.h>

// for delay.h
#define F_CPU 1000000UL
#include <util/delay.h>

#define DOT_VISIBLE_MS		250
#define DASH_VISIBLE_MS		1000
#define SYMBOL_PAUSE		330
#define CHAR_PAUSE			750
#define WORD_PAUSE			1000

void dot(void) {
	PORTD.OUTCLR = 0b00010000;
	_delay_ms(DOT_VISIBLE_MS);
	PORTD.OUTSET = 0b00010000;
	_delay_ms(SYMBOL_PAUSE);
}

void dash(void) {
	PORTD.OUTCLR = 0b00010000;
	_delay_ms(DASH_VISIBLE_MS);
	PORTD.OUTSET = 0b00010000;
	_delay_ms(SYMBOL_PAUSE);
}

void morseOK(void) {
	dash(); dash(); dash();		// O ---
	_delay_ms(CHAR_PAUSE);
	dash(); dot(); dash();		// K -.-
	
	_delay_ms(WORD_PAUSE * 3);
}

int main(void)
{
	PORTD.DIRSET = 0b00010000;
	PORTD.OUTSET = 0b00010000;
	
	while(1) {
		morseOK();
	}
}

